Index: code/branches/physics/src/bullet/LinearMath/btTransformUtil.h
===================================================================
--- code/branches/physics/src/bullet/LinearMath/btTransformUtil.h	(revision 2192)
+++ code/branches/physics/src/bullet/LinearMath/btTransformUtil.h	(revision 2430)
@@ -101,4 +101,36 @@
 	}
 
+	static void	calculateVelocityQuaternion(const btVector3& pos0,const btVector3& pos1,const btQuaternion& orn0,const btQuaternion& orn1,btScalar timeStep,btVector3& linVel,btVector3& angVel)
+	{
+		linVel = (pos1 - pos0) / timeStep;
+		btVector3 axis;
+		btScalar  angle;
+		if (orn0 != orn1)
+		{
+			calculateDiffAxisAngleQuaternion(orn0,orn1,axis,angle);
+			angVel = axis * angle / timeStep;
+		} else
+		{
+			angVel.setValue(0,0,0);
+		}
+	}
+
+	static void calculateDiffAxisAngleQuaternion(const btQuaternion& orn0,const btQuaternion& orn1a,btVector3& axis,btScalar& angle)
+	{
+		btQuaternion orn1 = orn0.farthest(orn1a);
+		btQuaternion dorn = orn1 * orn0.inverse();
+		///floating point inaccuracy can lead to w component > 1..., which breaks 
+		dorn.normalize();
+		angle = dorn.getAngle();
+		axis = btVector3(dorn.x(),dorn.y(),dorn.z());
+		axis[3] = btScalar(0.);
+		//check for axis length
+		btScalar len = axis.length2();
+		if (len < SIMD_EPSILON*SIMD_EPSILON)
+			axis = btVector3(btScalar(1.),btScalar(0.),btScalar(0.));
+		else
+			axis /= btSqrt(len);
+	}
+
 	static void	calculateVelocity(const btTransform& transform0,const btTransform& transform1,btScalar timeStep,btVector3& linVel,btVector3& angVel)
 	{
@@ -112,18 +144,9 @@
 	static void calculateDiffAxisAngle(const btTransform& transform0,const btTransform& transform1,btVector3& axis,btScalar& angle)
 	{
-	
-	#ifdef USE_QUATERNION_DIFF
-		btQuaternion orn0 = transform0.getRotation();
-		btQuaternion orn1a = transform1.getRotation();
-		btQuaternion orn1 = orn0.farthest(orn1a);
-		btQuaternion dorn = orn1 * orn0.inverse();
-#else
 		btMatrix3x3 dmat = transform1.getBasis() * transform0.getBasis().inverse();
 		btQuaternion dorn;
 		dmat.getRotation(dorn);
-#endif//USE_QUATERNION_DIFF
-	
+
 		///floating point inaccuracy can lead to w component > 1..., which breaks 
-
 		dorn.normalize();
 		
@@ -141,4 +164,84 @@
 };
 
+
+///The btConvexSeparatingDistanceUtil can help speed up convex collision detection 
+///by conservatively updating a cached separating distance/vector instead of re-calculating the closest distance
+class	btConvexSeparatingDistanceUtil
+{
+	btQuaternion	m_ornA;
+	btQuaternion	m_ornB;
+	btVector3	m_posA;
+	btVector3	m_posB;
+	
+	btVector3	m_separatingNormal;
+
+	btScalar	m_boundingRadiusA;
+	btScalar	m_boundingRadiusB;
+	btScalar	m_separatingDistance;
+
+public:
+
+	btConvexSeparatingDistanceUtil(btScalar	boundingRadiusA,btScalar	boundingRadiusB)
+		:m_boundingRadiusA(boundingRadiusA),
+		m_boundingRadiusB(boundingRadiusB),
+		m_separatingDistance(0.f)
+	{
+	}
+
+	btScalar	getConservativeSeparatingDistance()
+	{
+		return m_separatingDistance;
+	}
+
+	void	updateSeparatingDistance(const btTransform& transA,const btTransform& transB)
+	{
+		const btVector3& toPosA = transA.getOrigin();
+		const btVector3& toPosB = transB.getOrigin();
+		btQuaternion toOrnA = transA.getRotation();
+		btQuaternion toOrnB = transB.getRotation();
+
+		if (m_separatingDistance>0.f)
+		{
+			
+
+			btVector3 linVelA,angVelA,linVelB,angVelB;
+			btTransformUtil::calculateVelocityQuaternion(m_posA,toPosA,m_ornA,toOrnA,btScalar(1.),linVelA,angVelA);
+			btTransformUtil::calculateVelocityQuaternion(m_posB,toPosB,m_ornB,toOrnB,btScalar(1.),linVelB,angVelB);
+			btScalar maxAngularProjectedVelocity = angVelA.length() * m_boundingRadiusA + angVelB.length() * m_boundingRadiusB;
+			btVector3 relLinVel = (linVelB-linVelA);
+			btScalar relLinVelocLength = (linVelB-linVelA).dot(m_separatingNormal);
+			if (relLinVelocLength<0.f)
+			{
+				relLinVelocLength = 0.f;
+			}
+	
+			btScalar	projectedMotion = maxAngularProjectedVelocity +relLinVelocLength;
+			m_separatingDistance -= projectedMotion;
+		}
+	
+		m_posA = toPosA;
+		m_posB = toPosB;
+		m_ornA = toOrnA;
+		m_ornB = toOrnB;
+	}
+
+	void	initSeparatingDistance(const btVector3& separatingVector,btScalar separatingDistance,const btTransform& transA,const btTransform& transB)
+	{
+		m_separatingNormal = separatingVector;
+		m_separatingDistance = separatingDistance;
+		
+		const btVector3& toPosA = transA.getOrigin();
+		const btVector3& toPosB = transB.getOrigin();
+		btQuaternion toOrnA = transA.getRotation();
+		btQuaternion toOrnB = transB.getRotation();
+		m_posA = toPosA;
+		m_posB = toPosB;
+		m_ornA = toOrnA;
+		m_ornB = toOrnB;
+	}
+
+};
+
+
 #endif //SIMD_TRANSFORM_UTIL_H
 
Index: code/branches/physics/src/bullet/LinearMath/btVector3.h
===================================================================
--- code/branches/physics/src/bullet/LinearMath/btVector3.h	(revision 2192)
+++ code/branches/physics/src/bullet/LinearMath/btVector3.h	(revision 2430)
@@ -20,12 +20,16 @@
 #include "btQuadWord.h"
 
-///btVector3 can be used to represent 3D points and vectors.
-///It has an un-used w component to suit 16-byte alignment when btVector3 is stored in containers. This extra component can be used by derived classes (Quaternion?) or by user
-///Ideally, this class should be replaced by a platform optimized SIMD version that keeps the data in registers
+/**@brief btVector3 can be used to represent 3D points and vectors.
+ * It has an un-used w component to suit 16-byte alignment when btVector3 is stored in containers. This extra component can be used by derived classes (Quaternion?) or by user
+ * Ideally, this class should be replaced by a platform optimized SIMD version that keeps the data in registers
+ */
 class	btVector3 : public btQuadWord {
 
 public:
+  /**@brief No initialization constructor */
 	SIMD_FORCE_INLINE btVector3() {}
 
+  /**@brief Constructor from btQuadWordStorage (btVector3 inherits from this so is also valid)
+   * Note: Vector3 derives from btQuadWordStorage*/
 	SIMD_FORCE_INLINE btVector3(const btQuadWordStorage& q) 
 		: btQuadWord(q)
@@ -33,5 +37,9 @@
 	}
 	
-
+  /**@brief Constructor from scalars 
+   * @param x X value
+   * @param y Y value 
+   * @param z Z value 
+   */
 	SIMD_FORCE_INLINE btVector3(const btScalar& x, const btScalar& y, const btScalar& z) 
 		:btQuadWord(x,y,z,btScalar(0.))
@@ -45,26 +53,31 @@
 
 	
-
+/**@brief Add a vector to this one 
+ * @param The vector to add to this one */
 	SIMD_FORCE_INLINE btVector3& operator+=(const btVector3& v)
 	{
 
-		m_x += v.x(); m_y += v.y(); m_z += v.z();
+		m_floats[0] += v.x(); m_floats[1] += v.y(); m_floats[2] += v.z();
 		return *this;
 	}
 
 
-
+  /**@brief Subtract a vector from this one
+   * @param The vector to subtract */
 	SIMD_FORCE_INLINE btVector3& operator-=(const btVector3& v) 
 	{
-		m_x -= v.x(); m_y -= v.y(); m_z -= v.z();
+		m_floats[0] -= v.x(); m_floats[1] -= v.y(); m_floats[2] -= v.z();
 		return *this;
 	}
-
+  /**@brief Scale the vector
+   * @param s Scale factor */
 	SIMD_FORCE_INLINE btVector3& operator*=(const btScalar& s)
 	{
-		m_x *= s; m_y *= s; m_z *= s;
+		m_floats[0] *= s; m_floats[1] *= s; m_floats[2] *= s;
 		return *this;
 	}
 
+  /**@brief Inversely scale the vector 
+   * @param s Scale factor to divide by */
 	SIMD_FORCE_INLINE btVector3& operator/=(const btScalar& s) 
 	{
@@ -73,9 +86,12 @@
 	}
 
+  /**@brief Return the dot product
+   * @param v The other vector in the dot product */
 	SIMD_FORCE_INLINE btScalar dot(const btVector3& v) const
 	{
-		return m_x * v.x() + m_y * v.y() + m_z * v.z();
-	}
-
+		return m_floats[0] * v.x() + m_floats[1] * v.y() + m_floats[2] * v.z();
+	}
+
+  /**@brief Return the length of the vector squared */
 	SIMD_FORCE_INLINE btScalar length2() const
 	{
@@ -83,4 +99,5 @@
 	}
 
+  /**@brief Return the length of the vector */
 	SIMD_FORCE_INLINE btScalar length() const
 	{
@@ -88,8 +105,14 @@
 	}
 
+  /**@brief Return the distance squared between the ends of this and another vector
+   * This is symantically treating the vector like a point */
 	SIMD_FORCE_INLINE btScalar distance2(const btVector3& v) const;
 
+  /**@brief Return the distance between the ends of this and another vector
+   * This is symantically treating the vector like a point */
 	SIMD_FORCE_INLINE btScalar distance(const btVector3& v) const;
 
+  /**@brief Normalize this vector 
+   * x^2 + y^2 + z^2 = 1 */
 	SIMD_FORCE_INLINE btVector3& normalize() 
 	{
@@ -97,8 +120,14 @@
 	}
 
+  /**@brief Return a normalized version of this vector */
 	SIMD_FORCE_INLINE btVector3 normalized() const;
 
+  /**@brief Rotate this vector 
+   * @param wAxis The axis to rotate about 
+   * @param angle The angle to rotate by */
 	SIMD_FORCE_INLINE btVector3 rotate( const btVector3& wAxis, const btScalar angle );
 
+  /**@brief Return the angle between this and another vector
+   * @param v The other vector */
 	SIMD_FORCE_INLINE btScalar angle(const btVector3& v) const 
 	{
@@ -107,36 +136,41 @@
 		return btAcos(dot(v) / s);
 	}
-
+  /**@brief Return a vector will the absolute values of each element */
 	SIMD_FORCE_INLINE btVector3 absolute() const 
 	{
 		return btVector3(
-			btFabs(m_x), 
-			btFabs(m_y), 
-			btFabs(m_z));
-	}
-
+			btFabs(m_floats[0]), 
+			btFabs(m_floats[1]), 
+			btFabs(m_floats[2]));
+	}
+  /**@brief Return the cross product between this and another vector 
+   * @param v The other vector */
 	SIMD_FORCE_INLINE btVector3 cross(const btVector3& v) const
 	{
 		return btVector3(
-			m_y * v.z() - m_z * v.y(),
-			m_z * v.x() - m_x * v.z(),
-			m_x * v.y() - m_y * v.x());
+			m_floats[1] * v.z() - m_floats[2] * v.y(),
+			m_floats[2] * v.x() - m_floats[0] * v.z(),
+			m_floats[0] * v.y() - m_floats[1] * v.x());
 	}
 
 	SIMD_FORCE_INLINE btScalar triple(const btVector3& v1, const btVector3& v2) const
 	{
-		return m_x * (v1.y() * v2.z() - v1.z() * v2.y()) + 
-			m_y * (v1.z() * v2.x() - v1.x() * v2.z()) + 
-			m_z * (v1.x() * v2.y() - v1.y() * v2.x());
-	}
-
+		return m_floats[0] * (v1.y() * v2.z() - v1.z() * v2.y()) + 
+			m_floats[1] * (v1.z() * v2.x() - v1.x() * v2.z()) + 
+			m_floats[2] * (v1.x() * v2.y() - v1.y() * v2.x());
+	}
+
+  /**@brief Return the axis with the smallest value 
+   * Note return values are 0,1,2 for x, y, or z */
 	SIMD_FORCE_INLINE int minAxis() const
 	{
-		return m_x < m_y ? (m_x < m_z ? 0 : 2) : (m_y < m_z ? 1 : 2);
-	}
-
+		return m_floats[0] < m_floats[1] ? (m_floats[0] < m_floats[2] ? 0 : 2) : (m_floats[1] < m_floats[2] ? 1 : 2);
+	}
+
+  /**@brief Return the axis with the largest value 
+   * Note return values are 0,1,2 for x, y, or z */
 	SIMD_FORCE_INLINE int maxAxis() const 
 	{
-		return m_x < m_y ? (m_y < m_z ? 2 : 1) : (m_x < m_z ? 2 : 0);
+		return m_floats[0] < m_floats[1] ? (m_floats[1] < m_floats[2] ? 2 : 1) : (m_floats[0] < m_floats[2] ? 2 : 0);
 	}
 
@@ -154,22 +188,26 @@
 	{
 		btScalar s = btScalar(1.0) - rt;
-		m_x = s * v0.x() + rt * v1.x();
-		m_y = s * v0.y() + rt * v1.y();
-		m_z = s * v0.z() + rt * v1.z();
+		m_floats[0] = s * v0.x() + rt * v1.x();
+		m_floats[1] = s * v0.y() + rt * v1.y();
+		m_floats[2] = s * v0.z() + rt * v1.z();
 		//don't do the unused w component
 		//		m_co[3] = s * v0[3] + rt * v1[3];
 	}
 
+  /**@brief Return the linear interpolation between this and another vector 
+   * @param v The other vector 
+   * @param t The ration of this to v (t = 0 => return this, t=1 => return other) */
 	SIMD_FORCE_INLINE btVector3 lerp(const btVector3& v, const btScalar& t) const 
 	{
-		return btVector3(m_x + (v.x() - m_x) * t,
-			m_y + (v.y() - m_y) * t,
-			m_z + (v.z() - m_z) * t);
-	}
-
-
+		return btVector3(m_floats[0] + (v.x() - m_floats[0]) * t,
+			m_floats[1] + (v.y() - m_floats[1]) * t,
+			m_floats[2] + (v.z() - m_floats[2]) * t);
+	}
+
+  /**@brief Elementwise multiply this vector by the other 
+   * @param v The other vector */
 	SIMD_FORCE_INLINE btVector3& operator*=(const btVector3& v)
 	{
-		m_x *= v.x(); m_y *= v.y(); m_z *= v.z();
+		m_floats[0] *= v.x(); m_floats[1] *= v.y(); m_floats[2] *= v.z();
 		return *this;
 	}
@@ -179,4 +217,5 @@
 };
 
+/**@brief Return the sum of two vectors (Point symantics)*/
 SIMD_FORCE_INLINE btVector3 
 operator+(const btVector3& v1, const btVector3& v2) 
@@ -185,4 +224,5 @@
 }
 
+/**@brief Return the elementwise product of two vectors */
 SIMD_FORCE_INLINE btVector3 
 operator*(const btVector3& v1, const btVector3& v2) 
@@ -191,4 +231,5 @@
 }
 
+/**@brief Return the difference between two vectors */
 SIMD_FORCE_INLINE btVector3 
 operator-(const btVector3& v1, const btVector3& v2)
@@ -196,5 +237,5 @@
 	return btVector3(v1.x() - v2.x(), v1.y() - v2.y(), v1.z() - v2.z());
 }
-
+/**@brief Return the negative of the vector */
 SIMD_FORCE_INLINE btVector3 
 operator-(const btVector3& v)
@@ -203,4 +244,5 @@
 }
 
+/**@brief Return the vector scaled by s */
 SIMD_FORCE_INLINE btVector3 
 operator*(const btVector3& v, const btScalar& s)
@@ -209,4 +251,5 @@
 }
 
+/**@brief Return the vector scaled by s */
 SIMD_FORCE_INLINE btVector3 
 operator*(const btScalar& s, const btVector3& v)
@@ -215,4 +258,5 @@
 }
 
+/**@brief Return the vector inversely scaled by s */
 SIMD_FORCE_INLINE btVector3
 operator/(const btVector3& v, const btScalar& s)
@@ -222,4 +266,5 @@
 }
 
+/**@brief Return the vector inversely scaled by s */
 SIMD_FORCE_INLINE btVector3
 operator/(const btVector3& v1, const btVector3& v2)
@@ -228,4 +273,5 @@
 }
 
+/**@brief Return the dot product between two vectors */
 SIMD_FORCE_INLINE btScalar 
 dot(const btVector3& v1, const btVector3& v2) 
@@ -235,5 +281,5 @@
 
 
-
+/**@brief Return the distance squared between two vectors */
 SIMD_FORCE_INLINE btScalar
 distance2(const btVector3& v1, const btVector3& v2) 
@@ -243,4 +289,5 @@
 
 
+/**@brief Return the distance between two vectors */
 SIMD_FORCE_INLINE btScalar
 distance(const btVector3& v1, const btVector3& v2) 
@@ -249,4 +296,5 @@
 }
 
+/**@brief Return the angle between two vectors */
 SIMD_FORCE_INLINE btScalar
 angle(const btVector3& v1, const btVector3& v2) 
@@ -255,4 +303,5 @@
 }
 
+/**@brief Return the cross product of two vectors */
 SIMD_FORCE_INLINE btVector3 
 cross(const btVector3& v1, const btVector3& v2) 
@@ -267,4 +316,8 @@
 }
 
+/**@brief Return the linear interpolation between two vectors
+ * @param v1 One vector 
+ * @param v2 The other vector 
+ * @param t The ration of this to v (t = 0 => return v1, t=1 => return v2) */
 SIMD_FORCE_INLINE btVector3 
 lerp(const btVector3& v1, const btVector3& v2, const btScalar& t)
@@ -273,5 +326,5 @@
 }
 
-
+/**@brief Test if each element of the vector is equivalent */
 SIMD_FORCE_INLINE bool operator==(const btVector3& p1, const btVector3& p2) 
 {
@@ -317,5 +370,5 @@
 		: btVector3(x,y,z)
 	{
-		m_unusedW = w;
+		m_floats[3] = w;
 	}
 
@@ -324,13 +377,13 @@
 	{
 		return btVector4(
-			btFabs(m_x), 
-			btFabs(m_y), 
-			btFabs(m_z),
-			btFabs(m_unusedW));
-	}
-
-
-
-	btScalar	getW() const { return m_unusedW;}
+			btFabs(m_floats[0]), 
+			btFabs(m_floats[1]), 
+			btFabs(m_floats[2]),
+			btFabs(m_floats[3]));
+	}
+
+
+
+	btScalar	getW() const { return m_floats[3];}
 
 
@@ -339,23 +392,23 @@
 		int maxIndex = -1;
 		btScalar maxVal = btScalar(-1e30);
-		if (m_x > maxVal)
+		if (m_floats[0] > maxVal)
 		{
 			maxIndex = 0;
-			maxVal = m_x;
-		}
-		if (m_y > maxVal)
+			maxVal = m_floats[0];
+		}
+		if (m_floats[1] > maxVal)
 		{
 			maxIndex = 1;
-			maxVal = m_y;
-		}
-		if (m_z > maxVal)
+			maxVal = m_floats[1];
+		}
+		if (m_floats[2] > maxVal)
 		{
 			maxIndex = 2;
-			maxVal = m_z;
-		}
-		if (m_unusedW > maxVal)
+			maxVal = m_floats[2];
+		}
+		if (m_floats[3] > maxVal)
 		{
 			maxIndex = 3;
-			maxVal = m_unusedW;
+			maxVal = m_floats[3];
 		}
 		
@@ -372,23 +425,23 @@
 		int minIndex = -1;
 		btScalar minVal = btScalar(1e30);
-		if (m_x < minVal)
+		if (m_floats[0] < minVal)
 		{
 			minIndex = 0;
-			minVal = m_x;
-		}
-		if (m_y < minVal)
+			minVal = m_floats[0];
+		}
+		if (m_floats[1] < minVal)
 		{
 			minIndex = 1;
-			minVal = m_y;
-		}
-		if (m_z < minVal)
+			minVal = m_floats[1];
+		}
+		if (m_floats[2] < minVal)
 		{
 			minIndex = 2;
-			minVal = m_z;
-		}
-		if (m_unusedW < minVal)
+			minVal = m_floats[2];
+		}
+		if (m_floats[3] < minVal)
 		{
 			minIndex = 3;
-			minVal = m_unusedW;
+			minVal = m_floats[3];
 		}
 		
Index: code/branches/physics/src/bullet/VERSION
===================================================================
--- code/branches/physics/src/bullet/VERSION	(revision 2192)
+++ code/branches/physics/src/bullet/VERSION	(revision 2430)
@@ -1,2 +1,1 @@
-Bullet Collision Detection and Physics Library version 2.72
-http://bullet.googlecode.com
+2.73
